#!/usr/bin/bash

#
# generic installation quick hack
# wheel reinvented, but i did not want to learn a installation thingy
# for now. 
#





. ./setup.conf

##
##
## nothing to change below this nice little comment.
##
##


PROGNAME=$(head -n 1 PROGNAME)
if [ -z $PROGNAME ]; then
    echo "error with program name..."
    exit 1
fi

VERSION=$(head -n 1 VERSION)
if [ -z $VERSION ]; then
    echo "error with program version..."
    exit 1
fi


echo "Setup for: $PROGNAME $VERSION"


#
function postinstall {

    echo "doing postinstall..."

    do_exec ./POSTINSTALL.sh

}

function do_install {

    echo
    echo "installing from   : $SRC"
    echo "cot install path  : $DST"
    echo "links to binaries : $BINLINK"
    echo "proceed (y/n)?"
    read ANSW

    if [ "$ANSW" != "y" ]; then
	echo "installation aborted."
	exit 1;
    fi

    if [ -e "$DST" ]; then

	echo "$DST already exists."
	echo "overwrite (y/n)?"
	read ANSW

	if [ "$ANSW" != "y" ]; then
	    echo "installation aborted."
	    exit 1;
	fi

    fi

    echo "copying files..."

    do_exec "mkdir $DST"

    for P in $DIRS; do

	do_exec "mkdir $DST/$P"
	if [ -z "$JUSTLINK" ]; then
	    do_exec "cp $SRC/$P $DST/ -vaf"	
	else
	    binfiles=$(ls $SRC/$P/)
	    #echo "$binfiles"
	    for F in $binfiles; do
		do_exec "ln -vfs $SRC/$P/$F $DST/$P/$F"
	    done

	fi

    done

    echo "making bin links..."
    if [ -n "$BIN" -a -n "$DSTBIN" ]; then
	binfiles=$(ls ./$BIN/)
	#echo "$binfiles"
	for F in $binfiles; do
	    do_exec "ln -vfs $DSTBIN/$F $BINLINK/$F"
	done
    else
	echo "no binaries to link"
    fi


    postinstall
}

function do_tidy {

    echo "clean the toilets, roger wilco"
    do_exec "rm $SRC/*~ -vfR "

}

function do_dist {
    echo "building $PROGNAME distribution package"
    echo "The archive will be called $PROGNAME-$VERSION.tar.gz"
    echo "press ENTER to continue or STRG-C to abort"
    read

    echo "removing tmp files..."
    do_exec find . -name *~ -exec rm -f {} \;
    echo "removing old archives..."
    do_exec rm "$PROGNAME-$VERSION.tar.gz" -fv

    echo "removing old dist dirs"
    do_exec rm "$PROGNAME-$VERSION/*" -frv

    #do pre dist extra shell script
    if [ -x PREDIST.sh ]; then
	echo "executing predist script..."
	do_exec . PREDIST.sh
	echo "done"
    fi;
    
    FILES=$(ls)
    #echo "FILES: $FILES"
    #exit 0

    echo "makeing dist dir"
    do_exec mkdir "$PROGNAME-$VERSION"
    for f in $FILES; do
	echo "copy $f..."
        do_exec cp $f "$PROGNAME-$VERSION"/ -R
    done

    echo "building archive"
    do_exec tar -cvzf "$ARCH/$PROGNAME-$VERSION.tar.gz" "./$PROGNAME-$VERSION/"  --exclude='$PROGNAME-$VERSION.*' --exclude='CVS'

    echo "removing dist dir"
    do_exec rm "$PROGNAME-$VERSION/" -fr

    if [ -x POSTDIST.sh ]; then
	echo "executing postdist script..."
	do_exec . POSTDIST.sh "$ARCH/$PROGNAME-$VERSION.tar.gz" "$ARCH/$PROGNAME-$VERSION.wbm.tar"
	echo "done"
    fi;

    echo "done."
}



function doit {

    if [   -n "$*" ]; then
    for A in $*; do
    echo "$A"
    case $A in
	
	"uninstall")
	    echo "uninstalling..."
	    echo "not yet implemented, sorry..."
	    exit 0
	;;

	"install")
	    #do_install
	;;

	"justlink")
	    echo "linked installation, no file is copied, all files are just links"
	    echo "to $SRC"

	    JUSTLINK=1

	    #do_install
	;;

	"fake")
	    echo "do not execute, just talk."

	    NOFAKE=""
	;;

	"nofake")
	    echo "installation is no fake. ;)"

	    NOFAKE="1"
	;;

	"tidy")
	    do_tidy
	;;

	"dist")
	    do_dist
	;;

	"--help"|"-h")
	    echo
	    echo "usage $0 [fake|nofake] <install|uninstall|justlink|dist|tidy>"
	    echo
	    exit 0
	;;
	*)
	    echo "unknown option: $1"
	    echo "try $0 -h"
	    exit 1
	;;
    esac
    done
    else
	echo "no args given, try $0 -h"
	exit 1
    fi

}


doit $*

